/*******************************************************************************************************

This file contains all the javascript crap to run this Beasty site....

\*******************************************************************************************************/


var HebbAlpha = 0.1;		//** Alpha value for Hebbian learning, instar and outstar.... 

var theta = 0;				//** a clock variable. 
var layerNames = new Array();

var TrainingOn = false;

/*******************************************************************************************************

 All of the transfer functions. 
	All functions take 'n' as input and return 'a'. 

*******************************************************************************************************/

//******* Hard Limit. ********
function hardlim(n){
	if (n < 0) return 0; else return 1;
}

//****** Symmetrical Hard Limit. *******
function hardlims(n){
	if (n < 0) return -1; else return 1; 
}

//****** Linear. **********
function purelin(n){
	return n;
}

//******* Saturating Linear. *******
function satlin(n){
	if (n < 0) return 0;
	if (n > 1) return 1;
	return n;
}

//******* Symmetric Saturating Linear. *******
function satlins(n){
	if (n < -1) return -1;
	if (n > 1) return 1;
	return n;
}

//******* Log-Sigmoid ********
function logsig(n){
	return  ( 1 / ( 1 + Math.exp(-n) ) );
}

//******** Hyperbolic Tangent Sigmoid **********
function tansig(n){
	return ( ( 1 - Math.exp(-n) ) / ( 1 + Math.exp(-n) ) );
}

//******* Positive Linear *******
function poslin(n){
	if (n < 0) return 0; else return n;
}

/*******************************************************************************************************

	wee function to convert the index of the layer we looking at into binary.

*******************************************************************************************************/
function sortLayerIndex(num, binArray){
	var x;

	for (var i=binArray.length-1; i>=0; i--){
		x = Math.pow(2, i);
		binArray[i] = Math.floor( num / x );
		if (binArray[i] == 1) num -= x;
		if (binArray[i] == 0) binArray[i] = -1;	//** bipolar values **
	}
}


/*******************************************************************************************************

	Function to normalize the input vector... 

*******************************************************************************************************/
function normalize(vector){
	var tmp = 0;

	//*** Find the magnitude... ***
	//*** first sum the square of each component. ***
	for (i=0; i<vector.length; i++){
		tmp += (vector[i] * vector[i]);
	}

	//*** square root it all... ***
	tmp = Math.sqrt(tmp);

	//*** divide throughout by the magnitude. ***
	for (i=0; i<vector.length; i++){
		vector[i] = vector[i] / tmp;
	}
}


/*******************************************************************************************************

	Stuff for storing and evaluating Neurons. 

*******************************************************************************************************/

function neuronClass() {
	for (var i = 0, j = 0; i < arguments.length; i+=2, j++) {
		this[j] = new Neuron(neuronClass.arguments[i], neuronClass.arguments[i+1]);
	}
}

function Neuron(bias, func, stimulus){
	this.bias = bias;
	this.func = func;
	this.a = 0;
}

function evalNeuron(node, weights, P){
/*
	spitDebug("Node evaluation:<BR> Bias:" + node.bias + "<BR>");
	spitDebug("WeightVector:" + weights + "<BR>");
	spitDebug("InputVector:" + P + "<BR>");
*/
	//*** neuron is a neuron of structure Neuron. P is the input vector as an 1D array.. ***
	if (weights.length != P.length){
		alert("weight vector and P vector aren't same length. ("+weights.length+"/"+P.length+")");
		return;
	}
	if (node.func == '') return 0;

	//*** neuron equation: a = WP + b; ***
	var WP = node.bias;		//** add bias to our product.
	for (var i = 0; i < P.length; i++){
		WP += (weights[i] * P[i]);
	}

	node.a = eval(node.func + "(" + WP + ")");
	
//	spitDebug("WP = " + WP + "<BR>");

	return node.a;
}

//***** Function to evaluate a whole neural network. *******
function evalNN(input, output){
	//** let P = our input vector. A is our output vector. 
	//** k and i are counters.. 
	var i, j, k;
	var compet;
	
	//*** copy input to array P. ****
	P = new Array();
	for (k=0; k<input.length; k++){
		P[k] = input[k];
	}
	normalize(P);

	//*** loop through each layer, numbered in the LayerIDs array. ***
	for (i=0; i<LayerIDs.length; i++){
		nodesInThisLayer = eval("LayerWeights" + LayerIDs[i] + ".length");

		//** creata an array for this layers output. **
		A = new Array();
		
		spitDebug("Layer: " + i +".<BR>input P: " + P + "<BR>");
		//** Loop through all nodes in this layer and evaluate each. ***
		for (j=0; j<nodesInThisLayer; j++){
			A[j] = evalNeuron(eval("LayerNodes" + LayerIDs[i] + "["+j+"]"),
					eval("LayerWeights" + LayerIDs[i] + "["+j+"]"),
					P);
		}

		//*** See which one won the competition. ie the greatest. ***
		for (j=1, compet=0; j<A.length; j++){
			if (A[j] > A[compet]) compet = j;
		}

		if (TrainingOn)
			switch (LayerTraining[i]){
			case 'instar':
				//** just perform training on winning neuron. ***
				/*
				Replace compition with a proper lateral inhibition system, so that 
				the entopy of the layers weight are maintained. ie. some weight will be
				'negatively trained', to compensate for those being 'positively trained'.				
				*/
				instarTraining(P, A[compet], eval("LayerWeights" + LayerIDs[i] + "["+compet+"]"));
				break;

			case 'outstar':
				outstarTraining(A, P[compet], eval("LayerWeights" + LayerIDs[i]), compet);
				break;
			}

		spitDebug("<BR>output A: " + A + "<BR>");

		//** Now to copy output 'A' to 'P' for use as next layers input. **
		delete P;
		P = new Array();
		for (k=0; k<nodesInThisLayer; k++){
			P[k] = A[k];
		}
		delete A;
	}

	//** now to copy output to the output array passed in. ***
	for (k=0; k<P.length; k++){
		output[k] = P[k];
	}
	delete P;
	
}


/*******************************************************************************

	Network training functions... 

*******************************************************************************/
function noTraining(x, y, z){
}

function instarTraining(P, a, W){
	//** when a = 0, no learning occurs, so may as well bomb out.. **
	if (a == 0){ return; }
	
	for (var i = 0; i < W.length; i++){
		if (stimulus[i] != 0){
			//** move W vector towards P input vector by product of (HebbAlpha*a) ***
			W[i] += HebbAlpha * a * (P[i] - W[i]);
		}
	}
}

function outstarTraining(A, p, W, compet){
	if (OutstarAlpha == 0) return;

	if (p < -1) p = -1; //** clamp large daft input values. **
	if (p > 1) p = 1;	

	//*** loop through input weight coloun vector. ***
	for (var i = 0; i < W.length; i++){
		if (compet < W[i].length)
			//** move W COLUMN vector toward A output vector, by product of (HebbAlpha*p). ***
			W[i][compet] += HebbAlpha * OutstarAlpha * p * (A[i] - W[i][compet]);
	}
}


/*******************************************************************************

	Function to spit NN state to a cookie...

*******************************************************************************/
function spitNN2Cookie(){
	var weights = "B" + BeastID;
	var layerID = 0;
/*
	Cookie format
	-------------
	L - Layer.
	R - Row.
	W - Weight.

	L1 R0 W 0.1 W 0.2 W 0.3 R1 W 0.1 W 0.2 W 0.3 L2 R1 0.1 W ...
*/


	//** loop through layers of weights. ***
	for (var i = 0; i < LayerIDs.length; i++){

		//*** set start of layer, and give it's database id. ***
		layerID = LayerIDs[i];
		weights += "L" + layerID;

		//** loop through rows of weights matrices. **
		for (var j = 0; j < eval("LayerWeights"+layerID).length; j++){

			//** set start of row. **
			weights += "R" + j;

			//*** loop through weight matrix row elements. ***
			for (var k = 0; k < eval("LayerWeights"+layerID+"["+j+"]").length; k ++){
				//** add weight value. ***
				weights += "W" + eval("LayerWeights"+layerID+"["+j+"]["+k+"]");
			}
		}
	}

	var theCookie = "Beast=" + escape(weights) + ";path=/";
	if (theCookie.length > 4000) alert("Bummer! - Cookie too big!");
	document.cookie = theCookie;


}



function updateDB(){
	spitNN2Cookie();
	SubmitWin = window.open('submitter.php3', 'Submitter', 'height=20,width=300,menubar=no,scrollbars=yes,toolbar=no,resizable=yes');
}



