<?php
//*** This file will display a topological diagram of the neural network as a webpage form 
//*** such that you can edit it and tweak bits of it... 

require ("admincommon.php3");
require ("../../include/beastpass.php3");


/****************************************************************************************

First a while bunch of function for drawing out the neuran network using html
table and form elements. 

****************************************************************************************/

function drawInputNeurons($BeastID){
	//* Query all nodes in output layer. 
	$query = "SELECT nn_nodes.*,nn_ios.InOut FROM nn_nodes ";
	$query .= "LEFT JOIN nn_layers ON nn_layers.ID = nn_nodes.LayerID ";
	$query .= "LEFT JOIN nn_ios ON nn_ios.ID = nn_nodes.IOID ";
	$query .= "WHERE nn_layers.BeastID = '$BeastID' AND nn_layers.Type='0' ORDER BY ID";

	$result = DQ ($query);
	
	//* First spit out surround table. **
	echo "<TABLE CELLSPACING='0' CELLPADDING='3'>\n";
	echo "\t<TR>\n";
	
	//** Loop through all input nodes, each a table within a cell of major table. **
	$i = 0;
	while ($buf = mysql_fetch_array($result)){
		echo "\t\t<TD>\n";

		switch ($buf['InOut']){ 
			case 0: $style = "Uncond"; break;
			default: $style = "Node"; break;
		}
		
		if ($i == 0){
			echo "<INPUT TYPE='HIDDEN' NAME='FirstNode' VALUE='".$buf['ID']."'>\n\n";
		}

		echo "\t\t\t<TABLE BORDER='0' CELLSPACING='0' CELLPADDING='5' CLASS='$style'>\n";
		echo "\t\t\t\t<TR>\n";
		echo "\t\t\t\t\t<TH CLASS='$style'>\n";
		echo "\t\t\t\t\t\tNode: (R = " . $i . ")\n";
		echo "\t\t\t\t\t</TH>\n";
		echo "\t\t\t\t</TR>\n";
		echo "\t\t\t\t<TR>\n";
		echo "\t\t\t\t\t<TD CLASS='$style'>\n";
		echo "\t\t\t\t\t\tI/O:<SELECT NAME='Node_" . $buf['ID'] . "_IO'>\n";
		spitInputFuncSelect($buf['IOID']);
		echo "\t\t\t\t\t</TD>\n";
		echo "\t\t\t\t</TR>\n";
		echo "\t\t\t</TABLE>\n";		

		echo "\t\t</TD>\n\n";
		
		$i ++;
	}
	
	echo "\t</TR>\n</TABLE><BR>\n\n";
	


}


function drawOutputNeurons($LayerID){
	//* Query all nodes in input layer. 
	$result = DQ("SELECT nn_nodes.* FROM nn_nodes WHERE LayerID='$LayerID' ORDER BY ID");

	//* First spit out surround table. **
	echo "<TABLE CELLSPACING='0' CELLPADDING='3'>\n";
	echo "\t<TR>\n";
	
	//** Loop through all input nodes, each a table within a cell of major table. **
	$i = 0;
	while ($buf = mysql_fetch_array($result)){
		echo "\t\t<TD>\n";

		echo "\t\t\t<TABLE CELLSPACING='0' CELLPADDING='5' CLASS='Node'>\n";
		echo "\t\t\t\t<TR>\n";
		echo "\t\t\t\t\t<TH CLASS='Node'>\n";
		echo "\t\t\t\t\t\tNode: (R = " . $i . ")\n";
		echo "\t\t\t\t\t</TH>\n";
		echo "\t\t\t\t</TR>\n";
		echo "\t\t\t\t<TR>\n";
		echo "\t\t\t\t\t<TD CLASS='Node'>\n";
		echo "\t\t\t\t\t\tBias:<INPUT TYPE='TEXT' NAME='Node_".$buf['ID']."_Bias' SIZE='5' MAXLENGTH='5' VALUE='".$buf['Bias']."'>\n";
		echo "\t\t\t\t\t\t<BR>\n";
		echo "\t\t\t\t\t\t<I>f</I>:<SELECT NAME='Node_" . $buf['ID'] . "_Func'>\n";
		spitFuncSelect($buf['Func']);
		echo "\t\t\t\t\t\t<BR>\n";
		echo "\t\t\t\t\t\tI/O:<SELECT NAME='Node_" . $buf['ID'] . "_IO'>\n";
		spitOutputFuncSelect($buf['IOID']);
		echo "\t\t\t\t\t</TD>\n";
		echo "\t\t\t\t</TR>\n";
		echo "\t\t\t</TABLE>\n";		

		echo "\t\t</TD>\n\n";
		
		$i ++;
	}
	
	echo "\t</TR>\n</TABLE><BR>\n\n";
}

function drawNeurons($LayerID){
	//* Query all nodes in input layer. 
	$result = DQ("SELECT * FROM nn_nodes WHERE LayerID='$LayerID' ORDER BY ID");

	//* First spit out surround table. **
	echo "<TABLE  BORDER='0' CELLSPACING='0' CELLPADDING='3'>\n";
	echo "\t<TR>\n";
	
	//** Loop through all input nodes, each a table within a cell of major table. **
	$i = 0;
	while ($buf = mysql_fetch_array($result)){
		echo "\t\t<TD>\n";

		echo "\t\t\t<TABLE CELLSPACING='0' CELLPADDING='5' CLASS='Node'>\n";
		echo "\t\t\t\t<TR>\n";
		echo "\t\t\t\t\t<TH CLASS='Node'>\n";
		echo "\t\t\t\t\t\tNode: (R = " . $i . ")\n";
		echo "\t\t\t\t\t</TH>\n";
		echo "\t\t\t\t</TR>\n";
		echo "\t\t\t\t<TR>\n";
		echo "\t\t\t\t\t<TD CLASS='Node'>\n";
		echo "\t\t\t\t\t\tBias:<INPUT TYPE='TEXT' NAME='Node_".$buf['ID']."_Bias' SIZE='5' MAXLENGTH='5' VALUE='".$buf['Bias']."'>\n";
		echo "\t\t\t\t\t\t<BR>\n";
		echo "\t\t\t\t\t\t<I>f</I>:<SELECT NAME='Node_" . $buf['ID'] . "_Func'>\n";
		spitFuncSelect($buf['Func']);
		echo "\t\t\t\t\t\t<BR>\n";
		echo "\t\t\t\t\t</TD>\n";
		echo "\t\t\t\t</TR>\n";
		echo "\t\t\t</TABLE>\n";		

		echo "\t\t</TD>\n\n";
		
		$i ++;
	}
	
	echo "\t</TR>\n</TABLE><BR>\n\n";

}

function drawWeights($LayerID){
	//* Query all nodes in this layer. 
	$node_res = DQ("SELECT ID FROM nn_nodes WHERE LayerID='$LayerID'");

	//* First spit out surround table. **
	echo "<TABLE CELLSPACING='0' CELLPADDING='3' CLASS='Weight'>\n";
	
	$N = 0;
	
	//*** Loop through all nodes in this layer. ***
	while ($node_buf = mysql_fetch_array($node_res)){
		echo "\t<TR>\n";
		
		//*** grab all weights associated with this node. ***
		$weight_res = DQ("SELECT * FROM nn_weights WHERE OutNodeID = '" . $node_buf['ID'] . "'");
		$numOfColumns = mysql_num_rows($weight_res);

		//** if this is the first row, spit out a header row of indices. ***
		if ($N == '0'){
			echo "\t\t<TH CLASS='Weight'>&nbsp;</TH>\n";
			for ($i = 0; $i < $numOfColumns; $i++){
				echo "\t\t<TH CLASS='Weight'>R = $i</TH>\n";
			}
			echo "\t</TR>\n\t<TR>\n";
		}
		
		//** Put an index on the left hand column.... ***
		echo "\t\t<TH CLASS='Weight' WIDTH='50'>N = $N</TH>\n";
		
		//** Loop through all weights that are linked to this node. ***
		while ($weight_buf = mysql_fetch_array($weight_res)){
			echo "\t\t<TD CLASS='Weight'>\n";
			echo "\t\t\t<INPUT TYPE='TEXT' NAME='Weight".$weight_buf['ID']."' SIZE='8' MAXLENGTH='24' VALUE='".$weight_buf['Weight']."'>\n";
			echo "\t\t</TD>\n";		
		}
		
		echo "\t</TR>\n";
		$N ++;
	}	

	//*** decide how to normalize this weight matrix. ****
	echo "\t<TR>\n\t\t<TH CLASS='Weight' COLSPAN='".($numOfColumns+1)."'>\n";
	echo "<INPUT TYPE='RADIO' NAME='Normalize_$LayerID' VALUE='0' CHECKED>Normalize Nowt |\n";
	echo "<INPUT TYPE='RADIO' NAME='Normalize_$LayerID' VALUE='1'> Normalize Rows |\n";
	echo "<INPUT TYPE='RADIO' NAME='Normalize_$LayerID' VALUE='2'> Normalize Columns \n";
	echo "\t\t</TH>\n\t</TR>\n";

	echo "</TABLE><BR>\n\n";
}


function drawNN($BeastID){
	echo "<TABLE CELLSPACING='0' CELLPADDING='3' CLASS='Box'>\n";
	echo "<TR>\n<TH>\n";
	echo "<H3>Input Nodes <I>(S = 0)</I>:-</H3>\n";
	drawInputNeurons($BeastID);
	echo "</TH>\n</TR>\n";
	echo "</TABLE>\n<BR>\n\n";
	
	$i = 1;
	$result = DQ("SELECT * FROM nn_layers WHERE BeastID='$BeastID' AND Type > '0' ORDER BY Type DESC, ID ASC");
	$total = mysql_num_rows($result);
	while ($buf = mysql_fetch_array($result)){


		echo "<TABLE CELLSPACING='0' CELLPADDING='3' CLASS='Box'>\n";
		echo "<TR>\n<TH>\n";
		echo "<H3>Layer <I>S = $i</I>:- \n";
		echo "Training Method:-<SELECT NAME='Train".$buf['ID']."'>\n";
		spitTrainingSelect($buf['Training']);
		echo "</H3>\n";
		echo "</TH>\n</TR>\n";
		echo "<TR>\n<TH ALIGN='CENTER'>\n";

		echo "<H3>Weight Matrix:-</H3>\n";
		drawWeights($buf['ID']);

		if ($i != $total){
			echo "<H3>Hidden Layer:-</H3>\n";
			drawNeurons($buf['ID']);
		}else{
			echo "<H3>Output Layer:-</H3>\n";
			drawOutputNeurons($buf['ID']);
		}
		echo "</TH>\n</TR>\n";
		echo "</TABLE>\n<BR>\n\n";
		
		$i ++;
	}

}



/****************************************************************************************

This next chunk handles the submission of a neural network update. It will go through all 
the form elements, aka all the nodes and weights in the network, and update them. 

****************************************************************************************/
if ($Submit == "Update Beast" && $BeastID > 0){
	//*** quick security check... 
	if ($Pass != $beastpass){ 
		echo "<H1>Bad Pass</H1>\n\n";
		return; 
	}

	//*** first update x/y coords of beast. ***
	if ($Alive){ $AliveTicked = 1; }else{ $AliveTicked = 0; }
	DQ("UPDATE nn_beasts SET X ='$PosX', Y = '$PosY', Alive = '$AliveTicked' WHERE ID = '$BeastID'")			;

	//*** Go through all the layers updating training method. ***
	$layerResult = DQ("SELECT ID FROM nn_layers WHERE BeastID = '$BeastID' AND TYPE != 0");
	while ($buf = mysql_fetch_array($layerResult)){
		DQ("UPDATE nn_layers SET Training = '".$HTTP_POST_VARS["Train".$buf['ID']]."' WHERE ID = '".$buf['ID']."'");
	}

	//** Grab the ID's of all nodes of all the layers in this beast. . ***
	$query = "SELECT nn_nodes.ID FROM nn_nodes ";
	$query .= "LEFT JOIN nn_layers ON nn_layers.ID = nn_nodes.LayerID ";
	$query .= "WHERE nn_layers.BeastID = '$BeastID'";
	
	$result = DQ ($query);
	
	//*** Loop through all them nodes on all them layers. ****
	while ($buf = mysql_fetch_array($result)){
		$query = "UPDATE nn_nodes SET ";
				
		//** See if this node had any of the following form elements... 
		if (!empty($HTTP_POST_VARS["Node_" . $buf['ID'] . "_IO"])){
			$query .= "IOID = '".$HTTP_POST_VARS["Node_".$buf['ID']."_IO"]."'";
			$comma = ", ";
		}	
		if (!empty($HTTP_POST_VARS["Node_" . $buf['ID'] . "_Func"])){
			$query .= $comma . "Func = '".$HTTP_POST_VARS["Node_".$buf['ID']."_Func"]."'";
			$comma = ", ";
		}	
		if (!empty($HTTP_POST_VARS["Node_" . $buf['ID'] . "_Bias"])){
			$query .= $comma . "Bias = '".$HTTP_POST_VARS["Node_".$buf['ID']."_Bias"]."'";
			$comma = ", ";
		}	

		$query .= " WHERE ID='" . $buf['ID'] . "'";
		
		if (isset($comma)){ DQ ($query); unset($comma); }

		//*** grab ID's of weights that link to this node... 
		$result1 = DQ ("SELECT ID FROM nn_weights WHERE InNodeID = '" . $buf['ID'] . "'");
		while ($buf1 = mysql_fetch_array($result1)){
			DQ ("UPDATE nn_weights SET Weight = '" . $HTTP_POST_VARS["Weight".$buf1['ID']] . "' WHERE ID = '" . $buf1['ID'] . "'");
		}
	}

	//***** normalize weights now. ****
	mysql_data_seek($layerResult, 0);
	while ($buf = mysql_fetch_array($layerResult)){
		//*** see if we're normalizing rows for this layer. ***
		if ($HTTP_POST_VARS["Normalize_".$buf['ID']] == 1){
			//*** grab all nodes in this layer. *****
			$query = "SELECT ID FROM nn_nodes WHERE nn_nodes.layerID = '".$buf['ID']."' ORDER BY ID";
			$noderes = DQ($query);
			
			//**** loop through all them nodes we just grabbed. ****
			while ($nodebuf = mysql_fetch_array($noderes)){
				$weightMag = 0;
				//*** grab all weights that get input from this node. ****
				$weightres = DQ("SELECT * FROM nn_weights WHERE OutNodeID = '".$nodebuf['ID']."'");

				//*** loop through and sum sqr of weights to find magnitude. ***
				while ($weightbuf = mysql_fetch_array($weightres)){
					$weightMag += $weightbuf['Weight'] * $weightbuf['Weight'];
				}
				$weightMag = sqrt(abs($weightMag));
				if ($weightMag == 0){ die ("division by zero on weight vector normalization<BR>"); }

				//**** loop through weights again, dividing them by the normal & updating them. ****
				mysql_data_seek($weightres, 0);
				while ($weightbuf = mysql_fetch_array($weightres)){
					DQ("UPDATE nn_weights SET Weight = '".($weightbuf['Weight'] / $weightMag)."' WHERE ID = '".$weightbuf['ID']."'");
				}

			}

		}
		//*** or if we're normalizing columns... ****
		if ($HTTP_POST_VARS["Normalize_".$buf['ID']] == 2){
			//*** grab all nodes in this layer. *****
			//*** Note this makes the assumption that the layer above's ID is one less than the current. ***
			$query = "SELECT ID FROM nn_nodes WHERE nn_nodes.layerID = '".($buf['ID']-1)."' ORDER BY ID";
			$noderes = DQ($query);
			
			//**** loop through all them nodes we just grabbed. ****
			while ($nodebuf = mysql_fetch_array($noderes)){
				$weightMag = 0;
				//*** grab all weights that get input from this node. ****
				$weightres = DQ("SELECT * FROM nn_weights WHERE InNodeID = '".$nodebuf['ID']."'");

				//*** loop through and sum sqr of weights to find magnitude. ***
				while ($weightbuf = mysql_fetch_array($weightres)){
					$weightMag += $weightbuf['Weight'] * $weightbuf['Weight'];
				}
				$weightMag = sqrt(abs($weightMag));
				if ($weightMag == 0){ die ("division by zero on weight vector normalization<BR>"); }

				//**** loop through weights again, dividing them by the normal & updating them. ****
				mysql_data_seek($weightres, 0);
				while ($weightbuf = mysql_fetch_array($weightres)){
					DQ("UPDATE nn_weights SET Weight = '".($weightbuf['Weight'] / $weightMag)."' WHERE ID = '".$weightbuf['ID']."'");
				}

			}


		}

	}

}

if ($Submit == "Return to List"){
	unset($BeastID);
	unset($name);
	unset($done);
}

/****************************************************************************************

From here on, we drop back to HTML, for the header, styles etc. 

****************************************************************************************/
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>

<HEAD>
<TITLE>Beast in Depth</TITLE>

<META NAME='DESCRIPTION' CONTENT=''>

<META NAME='KEYWORDS' CONTENT=''>

<meta name='GENERATOR' content='nedit'>
<meta name='FORMATTER' content='nedit'>
<meta name='AUTHOR' content='Arthur J. Yarwood'>

<LINK href='beast_admin_styles.css' rel='stylesheet' type='text/css'>
</HEAD>

<BODY>

<?php 
/****************************************************************************************

This chunk is the main driver bit of the script... It sorts out the calling of all the 
previous functions to draw the neural network. 

****************************************************************************************/


	//** see if a beast id was passed in. ***
	if ($BeastID && !$done){
		$result = DQ ("SELECT *,(TO_DAYS(CURDATE()) - TO_DAYS(DOB)) AS Age FROM nn_beasts WHERE ID = '$BeastID'");
		$done = 1;
	}
	
	//*** see if a beasts name was passed in.. ***
	if ($name && !$done){
		$result = DQ ("SELECT *,(TO_DAYS(CURDATE()) - TO_DAYS(DOB)) AS Age FROM nn_beasts WHERE Name LIKE '$name'");
		$done = 1;
	}		

	if ($done){
		$buf = mysql_fetch_array($result);

		echo "<FORM METHOD='post' ACTION='" . $PHP_SELF . "'>\n";
	
		echo "<H1>A Beast called: <I>".$buf['Name']."</I></H1>\n";
		echo "<H4>Age: ".$buf['Age']." | Hits: ".$buf['Hits']." | \n";
		echo "X coord: <INPUT TYPE='TEXT' NAME='PosX' VALUE='".$buf['X']."' SIZE='4'> | \n";
		echo "Y coord: <INPUT TYPE='TEXT' NAME='PosY' VALUE='".$buf['Y']."' SIZE='4'> | \n";
		if ($buf['Alive'] == 1){
			echo "Alive: <INPUT TYPE='CHECKBOX' NAME='Alive[]' CHECKED> | \n";
		}else{
			echo "Alive: <INPUT TYPE='CHECKBOX' NAME='Alive[]'> | \n";
		}
		echo "<A HREF='../beast.php3?id=".$buf['ID']."'>View Beast</A></H4>\n";
		

		echo "<CENTER>\n";

		drawNN($buf['ID']); 

		echo "<INPUT TYPE='SUBMIT' NAME='Submit' VALUE='Update Beast'>\n\n";
		echo "<INPUT TYPE='SUBMIT' NAME='Submit' VALUE='Return to List'><BR>\n\n";
		echo "Password: <INPUT TYPE='PASSWORD' NAME='Pass'>\n\n";
		echo "<INPUT TYPE='HIDDEN' NAME='BeastID' VALUE='".$buf['ID']."'>\n\n";

		echo "</CENTER>\n\n";
		echo "</FORM>\n";
	}

	//*** default thing to do... get user to choose a beast. ***	
	if (!$done){
		$result = DQ ("SELECT *,(TO_DAYS(CURDATE()) - TO_DAYS(DOB)) AS Age FROM nn_beasts ORDER BY Name");

		echo "<H1>Choose the Beast you would like to view/edit.</H1>\n";
		while ($buf = mysql_fetch_array($result)){
			echo "<H4>";
			echo "<A HREF='" . $PHP_SELF . "?BeastID=" . $buf['ID'] . "'>\n";
			echo "Beast: ".$buf['Name']."</A>. Age: ".$buf['Age']." days. Hits: ".$buf['Hits'];
			echo "</H4>\n";
		}		
	}
?>

<p>
    <a href="http://validator.w3.org/check/referer"><img border="0"
        src="http://www.w3.org/Icons/valid-html401"
        alt="Valid HTML 4.01!" height="31" width="88"></a>
 </p>
</BODY>
</HTML>
